var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var imgBackgroundpng = new Image();
var imgimg3508png = new Image();
var imgimg3506png = new Image();
var imgimg3506png = new Image();
var imgimg3506png = new Image();
var imgimg3511png = new Image();
var imgimg3512png = new Image();
var imgimg3515png = new Image();
var imgBLACKOVERLAYpng = new Image();
var imgBLACKOVERLAYShadowpng = new Image();
var imgimg3519png = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    imgBackgroundpng.src = "Background.png";
    context.drawImage(imgBackgroundpng, 0, 0, 360, 360);
    context.restore();
    context.save();

    imgimg3508png.src = ".img3508.png";
    context.globalAlpha = 0.7
    context.drawImage(imgimg3508png, 104, 75, 153, 18);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "28px GearApplemint";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#313131";
    text = ((date.getDate()<10) ? "0"+date.getDate() : date.getDate().toString());
    context.fillText(text, 254, 184);
    context.restore();
    context.save();

    imgimg3506png.src = ".img3506.png";
    context.drawImage(imgimg3506png, 138, 245, 85, 55);
    context.restore();
    context.save();

    imgimg3506png.src = ".img3506.png";
    context.drawImage(imgimg3506png, 52, 155, 84, 54);
    context.restore();
    context.save();

    imgimg3506png.src = ".img3506.png";
    context.drawImage(imgimg3506png, 212, 155, 84, 54);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "28px GearApplemint";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#313131";
    text = dayOfWeek[date.getDay()];
    context.fillText(text, 93, 184);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "22px GearApplemint";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#313131";
    text = "Text";
    context.fillText(text, 180, 275);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg3511png.src = ".img3511.png";
    context.drawImage(imgimg3511png, -90, -116, 181, 232);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg3512png.src = ".img3512.png";
    context.drawImage(imgimg3512png, -122, -196, 244, 393);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg3515png.src = ".img3515.png";
    context.drawImage(imgimg3515png, -234, -223, 468, 446);
    context.restore();
    context.save();

    imgBLACKOVERLAYpng.src = "BLACKOVERLAY.png";
    context.drawImage(imgBLACKOVERLAYpng, 38, 57, 285, 244);
    context.restore();
    context.save();

    imgBLACKOVERLAYShadowpng.src = "BLACKOVERLAYShadow.png";
    context.drawImage(imgBLACKOVERLAYShadowpng, 38, 58, 285, 244);
    context.restore();
    context.save();

    imgimg3519png.src = ".img3519.png";
    context.globalAlpha = 0.2
    context.drawImage(imgimg3519png, 5, 5, 350, 350);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

};
